#include "stdafx.h"
#include "Communicator.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define SERVER_SMS		"smsgateapi.sms-sluzba.cz"			// sms-sluzba.cz
#define	PAGE_SMS		"apixml30/receiver"					// odeslani SMS
#define	PAGE_DELIVERY	"apixml30/sender"					// cteni potvrzeni

#define	SERVER_DIRECT	"directsmsapi.sms-sluzba.cz"		// directsms.sms-sluzba.cz
#define	PAGE_DIRECT		"receiver.asp"

#define	HEADER			"Content-Type: text/xml"

//#define TEST												// je-li definovano, odeslani zpravy se jen simuluje (neplati pro DirectSMS!)



/** Konstruktor, vynulovani nekterych promennych. */
CCommunicator::CCommunicator()
{
	hOpenHandle		= NULL;
	hConnectHandle	= NULL;
	hResourceHandle	= NULL;

	isSending		= FALSE;
	isCanceled		= FALSE;
}



/** Zjisteni, zda prave probiha odesilani SMS, resp. komunikace se serverem sluzba.cz, */
BOOL CCommunicator::IsSending()
{
	return isSending;
}



/** Preruseni odesilani, resp. komunikace se serverem sluzba.cz. */
void CCommunicator::Cancel()
{
	isCanceled = TRUE;

	if (hResourceHandle)
	{
		InternetCloseHandle(hResourceHandle);
		hResourceHandle = NULL;
	}

	if (hConnectHandle)
	{
		InternetCloseHandle(hConnectHandle);
		hConnectHandle = NULL;
	}

	if(hOpenHandle)
	{
		InternetCloseHandle(hOpenHandle);
		hOpenHandle = NULL;
	}

//	printf("Odesln bylo perueno uivatelem.");
}



/** Funkce pro http komunikaci. Je podporovan i pristup pres proxy server (jmeno+heslo). */
int CCommunicator::http(char *server, char *object, char *header, char *postData, int postSize, char *strUsername, char *strPassword, char *buf)
{
	DWORD		dwStatus;
	DWORD		dwStatusSize = sizeof(dwStatus);
	int			ok;
	CString		result;

//	printf(item, "Probh navazovn spojen...");

	hOpenHandle = InternetOpen("Mozilla/4.0 (compatible; SMS Gate Sender; Windows)", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if (!hOpenHandle)
	{
		result.Format("InternetOpen() failed. error=%i", GetLastError());
//		printf(result);
		return 1;
	}

	hConnectHandle = InternetConnect(hOpenHandle, server, INTERNET_DEFAULT_HTTPS_PORT, NULL, NULL, INTERNET_SERVICE_HTTP,0,0);
	if (!hConnectHandle)
	{
		result.Format("InternetConnect() failed. error=%i", GetLastError());
//		printf(result);
		InternetCloseHandle(hOpenHandle);
		return 2;
	}

	int flags =	  INTERNET_FLAG_KEEP_CONNECTION | INTERNET_FLAG_SECURE | INTERNET_FLAG_IGNORE_CERT_CN_INVALID
				| INTERNET_FLAG_IGNORE_CERT_DATE_INVALID
				| INTERNET_FLAG_NO_AUTO_REDIRECT | INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS
				| INTERNET_FLAG_NO_AUTH | INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP;

	hResourceHandle = HttpOpenRequest(hConnectHandle, "POST", object, NULL/*HTTP_VERSION*/, NULL, NULL, flags, 0);
	if (!hConnectHandle)
	{
		result.Format("HttpOpenRequest() failed. error=%i", GetLastError());
//		printf(result);
		InternetCloseHandle(hOpenHandle);
		return 3;
	}

	if (strUsername && strUsername[0] && strPassword && strPassword[0])
	{
		ok = InternetSetOption(hResourceHandle, INTERNET_OPTION_PROXY_USERNAME, strUsername, strlen(strUsername)+1);
		ok = InternetSetOption(hResourceHandle, INTERNET_OPTION_PROXY_PASSWORD, strPassword, strlen(strPassword)+1);
	}

	ok = HttpAddRequestHeaders(hResourceHandle, header, strlen(header), HTTP_ADDREQ_FLAG_REPLACE | HTTP_ADDREQ_FLAG_ADD);

	ok = HttpSendRequest(hResourceHandle, NULL, 0, postData, postSize);
	if (!ok)
	{
		result.Format("Odesln poadavku na HTTP server skonilo s chybou %i.", GetLastError());
//		printf(result);
		InternetCloseHandle(hOpenHandle);
		return 4;
	}

//	printf("Probh odesln dat...");

	ok = HttpQueryInfo(hResourceHandle, HTTP_QUERY_FLAG_NUMBER | HTTP_QUERY_STATUS_CODE, &dwStatus, &dwStatusSize, NULL);
	if (!ok)
	{
		result.Format("HttpQueryInfo() failed. chyba=%i", GetLastError());
//		printf(result);
		InternetCloseHandle(hOpenHandle);
		return 5;
	}

//	fprintf(stderr, "Status code: %i\n", dwStatus);
//	printf("ten odpovdi...");

	DWORD	n, pos=0;

	do
	{
		ok = InternetReadFile(hResourceHandle, buf+pos, sizeof(buf)-1, &n);
		if (!ok)
		{
			result.Format("ten dat z HTTP serveru skonilo s chybou %i.", GetLastError());
			return 6;
		}

		pos += n;
		buf[pos+n] = '\0';
	}while(n);

	ok = InternetCloseHandle(hOpenHandle);

	if (dwStatus != 200)
	{
		result.Format("Dolo k HTTP chyb %i.", dwStatus);
//		printf(result);
		return dwStatus;
	}

	return 0;
} 






/** Odstraneni diakritiky a nahrazeni nekterych znaku. */
CString CCommunicator::NormalizeText(CString msg)
{
	CString	txt(msg);															// txt obsahuje msg bez "nebezpecnych" znaku
																				// nejdrive odstraneni diakritiky
	txt.Replace('', 'a');
	txt.Replace('', 'e');
	txt.Replace('', 'e');
	txt.Replace('', 'i');
	txt.Replace('', 'y');
	txt.Replace('', 'o');
	txt.Replace('', 'u');
	txt.Replace('', 'u');

	txt.Replace('', 'A');
	txt.Replace('', 'E');
	txt.Replace('', 'E');
	txt.Replace('', 'I');
	txt.Replace('', 'Y');
	txt.Replace('', 'O');
	txt.Replace('', 'U');
	txt.Replace('', 'U');

	txt.Replace('', 'z');
	txt.Replace('', 's');
	txt.Replace('', 'c');
	txt.Replace('', 'r');
	txt.Replace('', 'd');
	txt.Replace('', 't');
	txt.Replace('', 'n');

	txt.Replace('', 'Z');
	txt.Replace('', 'S');
	txt.Replace('', 'C');
	txt.Replace('', 'R');
	txt.Replace('', 'D');
	txt.Replace('', 'T');
	txt.Replace('', 'N');
																				// dalsi znaky
	txt.Replace("&" , "&amp;" );
	txt.Replace("<" , "&lt;"  );
	txt.Replace(">" , "&gt;"  );
	txt.Replace("\"", "&quot;");
	txt.Replace("'" , "&apos;");

	return txt;
}


/** Prevod casu ve formatu "RRRRMMDDhhmmss" na "DD.MM.RRRR hh:mm:ss" */
CString CCommunicator::TimeToCas(CString t)
{
	CString	rok = t.Mid( 0,4);
	CString mes = t.Mid( 4,2);	if (mes[0]=='0') mes = mes[1];
	CString den = t.Mid( 6,2);	if (den[0]=='0') den = den[1];
	CString hod = t.Mid( 8,2);	if (hod[0]=='0') hod = hod[1];
	CString min = t.Mid(10,2);
	CString sec = t.Mid(12,2);

	CString cas = den + "." + mes + "."    + rok    + " " + hod + ":" + min + ":" + sec ;

	return cas;
}


/** Zjisteni aktualniho casu, ve formatu "DD.MM.RRRR hh:mm:ss". */
CString CCommunicator::CurrentDatetime()
{
time_t 		timer;
struct tm	*tm;
CString		datetime;

	timer = time(NULL);
	tm    = localtime(&timer);
	datetime.Format("%i.%i.%i %i:%02i:%02i",
						tm->tm_mday, tm->tm_mon+1, tm->tm_year+1900,
						tm->tm_hour,tm->tm_min,tm->tm_sec);

	return datetime;
}



/** Zjisteni textu podle tagu. */
CString CCommunicator::GetTextByTag(CString data, CString tagname)
{
	CString	text = "";

	int	start = data.Find("<"  + tagname + ">");
	if (start >= 0)
	{
		start += tagname.GetLength() + 2;

		int	stop  = data.Find("</" + tagname + ">", start);

		if (stop > start)
		{
			text = data.Mid(start, stop-start);
			text.TrimLeft ();
			text.TrimRight();
		}
	}

	return text;
}


/* Priklad odezvy:

<messages>
  <message>
    <id>420603476576-20080912123203217</id>

    <text>Testovaci zprava.</text>
    <send_at>20080912123203</send_at>
    <recipient>+420603476576</recipient>
    <parts>1</parts>
    <price>1.05</price>
  </message>

  <credit>18.95</credit>
</messages>

*/


/* Odeslani SMS pres directsms.sms-sluzba.cz */
int CCommunicator::SendSMSViaDirect(CString dir, CString dst, CString msg, CSmsInfo &info)
{
	int		err;
	char	buf[1024*8];
	char	data[1024];
	char	object[1024];

	sprintf(object, "%s/%s", dir, PAGE_DIRECT);

	sprintf(data,
			"<?xml version=\"1.0\" encoding=\"utf-8\" ?>"
			"<batch id=\"\">"
				"<request>textSMS</request>"
				"<recipient>%s</recipient>"
				"<content>%s</content>"
				"<udh />"
				"<delivery_report>20</delivery_report>"
				"<refid></refid>"
			"</batch>"
			, dst, NormalizeText(msg)
			);

	err = http(SERVER_DIRECT, object, HEADER, data, strlen(data), NULL, NULL, buf);

	if (err)
	{
		if (err > 200)
		{
			info.errMsg.Format("nastala http chyba %i."      , err);
		}
		else
		{
			info.errMsg.Format("nastala chyba komunikace %i.", err);
		}
	}
	else
	{
		err = atoi(GetTextByTag(buf, "status"));
		switch (err)
		{
			case 200:	info.errMsg.Format("%s hls: %s", SERVER_DIRECT, GetTextByTag(buf, "message") );
						err = 0;												// OK, vratit 0
						break;

			case 400:	info.errMsg.Format("%s hls neplatn poadavek.", SERVER_DIRECT);
						break;

			case 500:	info.errMsg.Format("%s hls doasn problm, opakujte poadavek pozdji.", SERVER_DIRECT);
						break;

			case 0:		err = 7;												// pro pripad, ze by status neobsahoval platne cislo
			default:	info.errMsg.Format("%s vrtil neznmou odezvu.", SERVER_DIRECT);
		}
	}

	return err;
}



/* Odeslani SMS pres sms-sluzba.cz */
int CCommunicator::SendSMSViaSms(CString usr, CString pwd, CString dst, CString msg, CSmsInfo &info)
{
	char	buf[1024*8];
	char	object[1024];
	char	data[1024];

	sprintf(object, "%s?login=%s&password=%s", PAGE_SMS, usr, pwd);

	sprintf(data  , "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
					"<outgoing_message>"
						"<text>%s</text>"
						"<recipient>%s</recipient>"
					"</outgoing_message>"
					, NormalizeText(msg), dst
					);

#ifdef TEST
																				// simulace
//!	Sleep(500);
	sprintf(buf,
			"<messages><message><id>420603476576-20080912123203217</id><text>%s</text><send_at>20080912123203</send_at><recipient>%s</recipient><parts>1</parts><price>1.05</price></message><credit>18.95</credit></messages>",
			msg, dst);
	TRACE("%s\n", buf);
	int err = 0;
	if (rand() % 5 == 0)
		err = 1;

#else																			// skutecne odeslani

	int err = http(SERVER_SMS, object, HEADER, data, strlen(data), NULL, NULL, buf);

#endif

	if (err)
	{
		if (err > 200)
		{
			info.errMsg.Format("nastala http chyba %i."      , err);
		}
		else
		{
			info.errMsg.Format("nastala chyba komunikace %i.", err);
		}
	}
	else
	{
		CString	id				= GetTextByTag(buf, "id"       );
		if (id.GetLength() < 8)
		{																		// chyba
			CString message		= GetTextByTag(buf, "message"  );

			if (message.GetLength() == 0)
			{
				info.errMsg = "chyba komunikace se serverem sms-sluzba.cz.";	// neznama odezva
			}
			else
			{
				info.errMsg = "sms-sluzba.cz hls: " + message;				// hlaska z odezvy
			}

			err = 7;
		}
		else
		{																		// OK
			CString send_at		= GetTextByTag(buf, "send_at"  );
			CString recipient	= GetTextByTag(buf, "recipient");
			CString price		= GetTextByTag(buf, "price"    );
			CString credit		= GetTextByTag(buf, "credit"   );

			info.id        = id;
			info.send_at   = TimeToCas(send_at);
			info.recipient = recipient;
			info.price     = atof(price);
			info.credit    = atof(credit);
		}
	}

	return err;

}



/** Zjisteni stavu dorucenky, podle id. */
int CCommunicator::GetDelivery(CString usr, CString pwd, CString id, CSmsInfo &info)
{
	int err;

	char	object[1024];
	char	buf[1024*8];

	sprintf(object, "%s?login=%s&password=%s&act=get_delivery_report&id=%s", PAGE_DELIVERY, usr, pwd, id);
	    	
	err = http(SERVER_SMS, object, HEADER, NULL, 0, NULL, NULL, buf);
	if (err)
	{
		if (err > 200)
		{
			info.errMsg.Format("nastala http chyba %i."      , err);
		}
		else
		{
			info.errMsg.Format("nastala chyba komunikace %i.", err);
		}

	}
	else
	{
		CString	id				= GetTextByTag(buf, "id"       );
		if (id.GetLength() < 8)
		{																		// chyba
			CString message		= GetTextByTag(buf, "message"  );

			if (message.GetLength() == 0)
			{
				info.errMsg = "chyba komunikace se serverem sms-sluzba.cz.";	// neznama odezva
				info.delivery_status = "?";										// stav doruceni se zkusi zjistit priste
			}
			else
			{
				info.errMsg = "sms-sluzba.cz hls: " + message;				// hlaska z odezvy			// id: "400;5" "Chybne ID zpravy" - nema cenu zjistovat ynovu
				info.delivery_status = "-";										// stav doruceni se uz nebude zjistovat
			}
		}
		else
		{																		// OK
			CString delivery_status		= GetTextByTag(buf, "status"  );
			CString delivery_timestamp	= GetTextByTag(buf, "delivery_timestamp");

			if (delivery_status == "0")
			{
				info.delivery_status    = "1";
				info.delivery_timestamp = TimeToCas(delivery_timestamp);		// stav doruceni zjisten (doruceno)
			}
			else
			{
				info.delivery_status = "?";										// stav doruceni se zkusi zjistit priste
			}

		}
	}

	return err;
}

