#include "stdafx.h"
#include <stdio.h>
#include "Communicator.h"


typedef int (*t_SendSms        ) (CString usr, CString pwd, CString dst, CString msg, CSmsInfo &info);
typedef int (*t_GetDeliveryInfo) (CString usr, CString pwd, CString id, CSmsInfo &info);

t_SendSms			SendSms;
t_GetDeliveryInfo	GetDeliveryInfo;

#define DLL_FNAME	"SmsGateApiDll.dll"


#define	DESTINATION "603000000"
#define USER		"test"
#define PASSWORD	"test"



int main(int argc, char *argv[])
{
	HINSTANCE m_hLib = LoadLibrary(DLL_FNAME);
	if (m_hLib == NULL)
	{
		printf("Nelze nahrat knihovnu: %s", DLL_FNAME);
		exit(1);
	}

	SendSms		= (t_SendSms       )GetProcAddress( m_hLib, "SendSms");
	GetDeliveryInfo= (t_GetDeliveryInfo       )GetProcAddress( m_hLib, "GetDeliveryInfo");
	if (!SendSms || !GetDeliveryInfo)
	{
		printf("Knihovna %s neobsahuje pozadovane funkce.", DLL_FNAME);
		exit(1);
	}

	// ---------------------------------------------------

	CSmsInfo	info;
	int			rc;

	rc = SendSms(USER, PASSWORD, DESTINATION, "Testovaci SMS...", info);
	printf("rc=%i cena=%.2fKc kredit=%.2fKc id=%s chyba=%s\n", rc, info.price, info.credit, info.id, info.errMsg);

	if (rc == 0)
	{
		for (int i=0; i<5; i++)
		{
			Sleep(5*1000);
			rc = GetDeliveryInfo(USER, PASSWORD, info.id, info);
			printf("rc=%i status=%s timestamp=%s chyba=%s\n", rc, info.delivery_status, info.delivery_timestamp, info.errMsg);
		}
	}

	return rc;
}
